#!/usr/bin/perl

BEGIN {
	require "fatlib.pl";
};

use utf8;
use strict;

# "1.150n"-"1.199n"
my $VER="V.1.170n(nanakochi123456)";
my $tarball="power111207.tar.gz";
my $data_update=<<EOM;
<li>2011/12/07 14:40 東京電力エリア更新</li>
<li>2011/12/02 10:05 モバイル版のトップページをシンプルにした。</li>
<li>2011/12/01 06:30 関西・九州電力電力使用量を追加</li>
<li>2011/11/19 08:00 デザイン変更、一部修正</li>
<li>2011/11/09 04:26 今冬の電力需要について記載</li>
<li>2011/9/30 18:05 節電の心得を冬版に変更した。</li>
<li>2011/9/30 16:30 タイムテーブルの10月分を、東京電力は公式HPの確認にて、東北電力は電話で原則実施せず、スケジュールを組んでいないことからから削除した。なお、検索結果には表示されますが、万が一の天災や発電所の設備に故障に見られた場合、事前予告ありで計画停電が実際される可能性があります。</li>
<li>2011/9/25 08:33 タイムテーブルの10月分(仮)を掲載した。各電力会社公式には記載記載されていません。今夏は、原則実施しないを達成できた為全くないと思われますが、念のため掲載しておきます。また、以前更新した時、東北エリアの9月分が欠落しているのも修正しました。</li>
<li>2011/9/01 04:05 東京電力エリア更新(埼玉)、郵便番号データベース更新</li>
<li>2011/8/10 12:30 東京電力エリア更新(千葉・神奈川・静岡)</li>
<li>2011/8/03 07:18 runtable.txt の内容を削除。ただしファイルは必要です。</li>
<li>2011/7/21 20:25 一部の郵便番号を検索できないのを修正。なお、それでも地域が多すぎる場合があります。</li>
<li>2011/7/21 20:00 東北エリア大幅更新　グループ30まであります。</li>
<li>2011/7/21 16:10 東京電力エリア更新（神奈川・埼玉）</li>
<li>2011/7/19 09:20 東北エリアを可能な限り町名を追加した。及び、郵便番号データベースの更新</li>
<li>2011/7/08 17:48 エリアの群馬・神奈川が更新されました。</li>
EOM

my $engine_update=<<EOM;
<li>2011/12/02 10:12 検索した際、スケジュールなしが表示されないのを修正した。</li>
<li>2011/12/01 08:00 関西電力の使用量一覧を運用再開した。</li>
<li>2011/11/19 09:30 九州電力の電気使用一覧を作成した。</li>
EOM

#------------
use Encode;
use CGI;
use HTTP::Lite;
use Encode qw/decode decode_utf8/;
use Encode::Guess;

require "common.pl";

$VER=~s/\(.*//g;

if($ENV{QUERY_STRING} eq "kepco" || $ENV{QUERY_STRING} eq "tohoku" || $ENV{QUERY_STRING} eq "cepco") {
	print <<EOM;
Content-type: text/plain

EOM
	$ENV{QUERY_STRING}=~s/\/\.//g;
	if(open(R,"cache/$ENV{QUERY_STRING}.twitter")) {
		my $buf;
		foreach(<R>) {
			$buf.=$_;
		}
		Encode::from_to($buf, "utf8", "shiftjis" );
		print $buf;
		close(R);
	}
	exit;
}

if($ENV{QUERY_STRING}=~/cmd\=twitter\_proxy/) {
	&twitter_proxy;
	exit;
}

my $nojapaneseflg=0;
$nojapaneseflg=1 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/en/);
$nojapaneseflg=0 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/ja/);
my $mobileflg=0;
$mobileflg=1 if($ENV{HTTP_USER_AGENT}=~/DoCoMo|UP\.Browser|KDDI|SoftBank|Voda[F|f]one|J\-PHONE|DDIPOCKET|WILLCOM|iPod|PDA|Mobile|Semulator/);

$mobileflg=0 if($ENV{QUERY_STRING}=~'p');
$mobileflg=1 if($ENV{QUERY_STRING}=~'m');
$nojapaneseflg=0 if($ENV{QUERY_STRING}=~'j');
$nojapaneseflg=1 if($ENV{QUERY_STRING}=~'e');

my $english_file="english.html";
my $english_mobile_file="english_mobile.html";
my $mobile_file="mobile.html";
my $pc_file="pc.html";
my $mobile_update_file="mobile_update.html";
my $mobile_setuden_file="mobile_setuden.html";
my $mobile_twitter_file="mobile_twitter.html";
my $mobile_announce_file="mobile_announcement.html";

&gzip_compress("Content-type: text/html; charset=utf-8");
my $body;
my $file;
my $kanaflg=0;
my $updatetitle;
if($nojapaneseflg) {
	if($mobileflg) {
		$file=$english_mobile_file;
	} else {
		$file=$english_file;
	}
} elsif($ENV{QUERY_STRING}=~/^mju/) {
	$file=$mobile_update_file;
	$kanaflg=1;
} elsif($ENV{QUERY_STRING}=~/^mjs/) {
	$file=$mobile_setuden_file;
	$kanaflg=1;
} elsif($ENV{QUERY_STRING}=~/^mja/) {
	$file=$mobile_announce_file;
	$kanaflg=1;
} elsif($ENV{QUERY_STRING}=~/^mjt/) {
	$file=$mobile_twitter_file;
	$kanaflg=1;
} elsif($mobileflg) {
	$file=$mobile_file;
	$kanaflg=1;
} else {
	$file=$pc_file;
}

if(open(R,"<:utf8","$file")) {
	foreach(<R>) {
		if(/\@\@/) {
			s/\@\@VER\@\@/$VER/;
			s/\@\@INCLUDE\=\"(.+)\"\@\@/@{[&include($1)]}/;
			s/\@\@INCLUDESCRIPT\=\"(.+)\"\@\@/@{[&include($1,1)]}/;
			s/\@\@QRCODEEN\@\@/@{[&qrcode_link_en]}/;
			s/\@\@QRCODEJP\@\@/@{[&qrcode_link]}/;
			s/\@\@DATAUPDATE\@\@/$data_update/;
			s/\@\@ENGINEUPDATE\@\@/$engine_update/;
			s/\@\@TARBALL\@\@/$tarball/;
			s/\@\@POWERUSAGE\@\@/@{[&powerusage]}/;
		}
		$body.=$_;
	}
	close(R);
} else {
	$body="$file not found. sorry.";
}
if($kanaflg) {
	$body=&z2h($body);
}
binmode(STDOUT, ":utf8");
print "$body\n";
close(STDOUT);
exit;

sub include {
	my ($file,$mode)=@_;
	my $body="";
	if(open(I,"<:utf8","$file")) {
		my $div=$file;
		$div=~s/\.//g;
		$body.=<<EOM if($mode ne 1);
<div id="$div">
EOM
		foreach(<I>) {
			$body.=$_;
		}
		close(I);
		$body.="</div>\n" if($mode ne 1);
	}
	$body;
}

sub qrcode_link {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath");
	if(&load_module("GD") && &load_module("GD::Barcode")) {
		return <<FIN;
携帯へURLを送るには、こちらのQRコードをご利用下さい。<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub qrcode_link_en {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath?e");
	if(&load_module("GD::Barcode")) {
		return <<FIN;
If you have mobile phone to transfer this site, use this barcode.
<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub powerusage {
	my $powerusage_url="http://denkiyohou.daiba.cx/?allcompany";
	my $http=new HTTP::Lite;
	$http->method("GET");
	$http->http11_mode(1);
	$http->add_req_header("User-Agent","KeikakuTeiden ($::basepath))");
	my $req=$http->request($powerusage_url);
	my $body=' ';
	if($req eq 200) {
		$body=$http->body();
		$body=&force_decode($body);
		my $out;
		my $crlfcnt=0;
		foreach(split(/\n/,$body)) {
			$out.="$_";
			if($crlfcnt eq 0) {
				$crlfcnt=1;
			} else {
				$crlfcnt=0;
				$out.="<br />";
			}
		}
		return $out;
	}
	return ' ';
}

sub twitter_proxy {
	my $query=new CGI;
	my $rpp=$query->param('rpp');
	my $q=&enc($query->param('q'));
	my $near=$query->param('near');
	my $within=$query->param('widhin');
	my $units=$query->param('units');
	my $since_id=$query->param('since_id');
	my $callback=$query->param('callback');

	my $searchurl="http://search.twitter.com/search.json";
	$searchurl.="?rpp=$rpp&callback=$callback&q=$q";
	my ($status,$stream)=&httpcl($searchurl);

	if($status eq 0) {
		&gzip_compress("Content-type: application/json");
		print $stream;
	} else {
		print "Content-type: text/plain\n\n";
		print "Cant get '$searchurl'\n";
	}
	exit;
}
